package com.liang.dao;

import com.liang.entity.StaSourceFee;
import com.liang.entity.StaTempmember;
import com.spire.ms.System.Security.Cryptography.MACTripleDES;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 项目人员（主要完成人）(StaTempmember)表数据库访问层
 *
 * @author makejava
 * @since 2023-07-03 16:32:41
 */
public interface StaTempmemberDao {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    StaTempmember queryById(Integer id);

    /**
     * 查询指定行数据
     *
     * @param staTempmember 查询条件
     * @param pageable      分页对象
     * @return 对象列表
     */
    List<StaTempmember> queryAllByLimit(StaTempmember staTempmember, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param staTempmember 查询条件
     * @return 总行数
     */
    long count(StaTempmember staTempmember);

    /**
     * 新增数据
     *
     * @param staTempmember 实例对象
     * @return 影响行数
     */
    int insert(StaTempmember staTempmember);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<StaTempmember> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<StaTempmember> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<StaTempmember> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<StaTempmember> entities);

    /**
     * 修改数据
     *
     * @param staTempmember 实例对象
     * @return 影响行数
     */
    int update(StaTempmember staTempmember);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    int deleteByFysq(Integer fysq);

    /**
     * 获取临时人员信息
     *
     * @param
     * @return
     */
    List<StaTempmember> getMemberList(Map map);

    /**
     * 批量删除临时人员
     *
     * @param fysqList
     * @return
     */
    int batchDeleteByFysq(List<Integer> fysqList);

    /**
     * 批量删除临时人员
     *
     * @param zb
     * @return
     */
    int batchDeleteByZb(int zb);

    /**
     * 获取临时人员信息
     *
     * @param map
     * @return
     */
    StaTempmember getTempMember(Map map);

    /**
     * 统计报表查询所有临时人员费
     *
     * @return
     */
    List<HashMap<String, Object>> getAllTemeMemberCost();

    /**
     * 获取列表
     *
     * @return
     */
    List<StaTempmember> getLSList(Integer zb);


    /**
     * 通过条件查询临时费用信息
     *
     * @param MC        项目名称
     * @param SSBMNAME  临时人员姓名
     * @param SQRQStart 聘用起始日期
     * @param SQRQEnd   聘用截止日期
     * @param QSRQ      创建起始日期
     * @param JZRQ      创建结束日期
     * @return
     */
    List<HashMap<String, Object>> searchTemeMemberCost(Map map);


    StaTempmember getXm(Map map);

    int upSt(Map map);

    List<StaTempmember> getAlls(Map map);

}

